<?php

namespace backend\controllers;

use backend\models\Frapl01;
use backend\models\Frapl01Search;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * Frapl01Controller implements the CRUD actions for Frapl01 model.
 */
class Frapl01Controller extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Frapl01 models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new Frapl01Search();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Frapl01 model.
     * @param string $FRAPL01_UUID Frapl01 Uuid
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($FRAPL01_UUID)
    {
        return $this->render('view', [
            'model' => $this->findModel($FRAPL01_UUID),
        ]);
    }

    /**
     * Creates a new Frapl01 model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Frapl01();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'FRAPL01_UUID' => $model->FRAPL01_UUID]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Frapl01 model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $FRAPL01_UUID Frapl01 Uuid
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($FRAPL01_UUID)
    {
        $model = $this->findModel($FRAPL01_UUID);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'FRAPL01_UUID' => $model->FRAPL01_UUID]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Frapl01 model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $FRAPL01_UUID Frapl01 Uuid
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($FRAPL01_UUID)
    {
        $this->findModel($FRAPL01_UUID)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Frapl01 model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $FRAPL01_UUID Frapl01 Uuid
     * @return Frapl01 the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($FRAPL01_UUID)
    {
        if (($model = Frapl01::findOne(['FRAPL01_UUID' => $FRAPL01_UUID])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
